﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Orchard.Services;
using EmailObfuscator.Contracts.Obfuscators;
using Orchard;
using Orchard.DisplayManagement.Shapes;
using Orchard.DisplayManagement.Descriptors;
using Orchard.DisplayManagement.Implementation;
using Orchard.Security;


namespace EmailObfuscator.HtmlFilters
{
    public class EmailHtmlFilter : IHtmlFilter
    {
        #region fields

        IWorkContextAccessor _workContextAccessor;

        #endregion

        #region Constructor

        /// <summary>
        /// constructor for the EMailHtmlFilter, automagicly uses  Orchards Dependency injection
        /// </summary>
        /// <param name="workContextAccessor">interface of orchards workContext</param>
        public EmailHtmlFilter(IWorkContextAccessor workContextAccessor)
        {
            _workContextAccessor = workContextAccessor;
        }

        #endregion

        #region IHtmlFilter

        /// <summary>
        /// implementation of IHtmlFilter
        /// </summary>
        /// <param name="text">incoming html (may contain raw mail addresses)</param>
        /// <returns>processed html (with obfuscated mail addresses)</returns>
        public string ProcessContent(string text,string flavor)
        {
            //DISABLE CONFUSCATION FOR CERTAIN PAGES ?
            //var context = _workContextAccessor.GetContext();                    //orchard workContext
            //var applicationPath = context.HttpContext.Request.ApplicationPath;  //System.web context

            var obfuscator = new EmailObfuscator.Obfuscators.EmailObfuscator(); //use IoC ?
            return obfuscator.Obfuscate(text);
        }


        #endregion

    }
}